unit Unit1; 

{$mode Delphi}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, SynEdit, SynHighlighterPas, delforinterf, delfortypes;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    SynEdit1: TSynEdit;
    SynEdit2: TSynEdit;
    SynPasSyn1: TSynPasSyn;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Form1: TForm1;
  Settings: Tsettings;

implementation

uses Unit2;

{ TForm1 }

procedure SetDefault;
begin
with settings do begin
  WrapLines := False;
  WrapPosition := 81;
  AlignCommentPos := 40;
  AlignComments := False;
  AlignVarPos := 20;
  AlignVar := False;
  SpaceEqualOper := spBoth;
  SpaceOperators := spBoth;
  SpaceColon := spAfter;
  SpaceComma := spAfter;
  SpaceSemiColon := spAfter;
  SpaceLeftBr := spNone;
  SpaceRightBr := spNone;
  SpaceLeftHook := spNone;
  SpaceRightHook := spNone;
  ReservedCase := rfLowerCase;
  StandDirectivesCase := rfLowerCase;
  ChangeIndent := True;
  indentBegin := False;
  IndentComments := False;
  IndentCompDirectives := False;
  IndentTryElse := False;
  IndentCaseElse := False;
  FeedAfterThen := False;
  ExceptSingle := False;
  FeedElseIf := False;
  FeedEachUnit := False;
  NoFeedBeforeThen := False;
  NoIndentElseIf := False;
  FeedAfterVar := False;
  FeedBeforeEnd := False;
  FeedRoundBegin := UnChanged;
  FeedAfterSemiColon := False;
  FillNewWords := fmUnchanged;
  IndentTry := False;
  UpperCompDirectives := True;
  UpperNumbers := True;
  SpacePerIndent := 2;
  BlankProc := True;
  RemoveDoubleBlank := False;
  BlankSubProc := False;
  StrCopy(StartCommentOut, '{(*}');
  StrCopy(EndCommentOut, '{*)}');
  end;
end;

procedure SetBorland;
begin
  with settings do begin
    WrapLines := True;
    IndentComments := True;
    FeedAfterThen := True;
    ExceptSingle := False;
    NoFeedBeforeThen := True;
    FeedAfterVar := True;
    FeedBeforeEnd := True;
    FeedRoundBegin := NewLine;
    FeedAfterSemiColon := True;
    RemoveDoubleBlank := True;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  showmessage(inttostr(Formatter_Version));
end;

procedure TForm1.Button1Click(Sender: TObject);
var s: String;
    p: pChar;
begin
  s := SynEdit1.Text;
  p  := @s[1];
  Formatter_Clear;
  Formatter_SetTextStr(p);
  Formatter_Parse(@settings,sizeof(settings));
  p := Formatter_GetTextStr;
  SynEdit2.Text := P;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  close;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  GetSettings(Settings);
  // Anzeigen des Dialoges..
  form2.showmodal;
end;

procedure TForm1.Button5Click(Sender: TObject);
var f:TFilestream;
begin
  IF SaveDialog1.EXECUTE then begin
  f := Tfilestream.create(SaveDialog1.FileName, fmcreate or fmopenwrite);
  f.write(settings, sizeof(Settings));
  f.free;
  end;
end;

procedure TForm1.Button6Click(Sender: TObject);
var f:TFilestream;
begin
  if opendialog1.execute then begin
    f := TFilestream.create(opendialog1.filename, fmopenread);
    f.read(Settings, sizeof(TSettings));
    f.free;
  end;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: boolean);
begin
  Formatter_Destroy;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Formatter_Create;
  SetDefault;
  SetBorland;
  //(*
  //Meine Ultra Coolen Settings hier Hardcoded !!
  //*)
  //// Indent
  //Settings.SpacePerIndent := 2;
  //Settings.IndentComments := True;
  //// Spacing
  //Settings.SpaceEqualOper := spBoth;
  //Settings.SpaceOperators := spBoth;
  //Settings.SpaceColon := spAfter;
  //Settings.SpaceSemiColon := spAfter;
  //Settings.SpaceComma := spAfter;
  //Settings.ChangeIndent := Settings.indentBegin or
  //  Settings.IndentTry or
  //  Settings.IndentTryElse or
  //  Settings.IndentCaseElse or
  //  Settings.IndentComments or
  //  Settings.IndentCompDirectives;
  //// Line break
  //Settings.FeedAfterVar := true;
  //Settings.FeedAfterSemiColon := True;
  //Settings.FeedAfterThen := true;
  //Settings.ExceptSingle := true;
  //Settings.RemoveDoubleBlank := true;
  //Settings.RemoveDoubleBlank := false;
  //Settings.BlankProc := true;
  //Settings.WrapPosition := 81;
  //Settings.FeedRoundBegin := Hanging;
  //// Capitalization
  //settings.ReservedCase := rfFirstUp;
  //settings.StandDirectivesCase := rfLowerCase;
  //settings.UpperCompDirectives := true;
  //settings.UpperNumbers := true;
  //// Align
  //Settings.AlignCommentPos := 40;
  //settings.AlignVarPos := 20;
  //// Misc.
  //Settings.StartCommentOut := '{(*}';
  //Settings.EndCommentOut := '{*)}';
end;

initialization
  {$I unit1.lrs}

end.

