unit Unit2; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, StdCtrls, Spin, Grids, delfortypes;

type

  { TForm2 }

  TForm2 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    CheckBox1: TCheckBox;
    CheckBox10: TCheckBox;
    CheckBox11: TCheckBox;
    CheckBox12: TCheckBox;
    CheckBox13: TCheckBox;
    CheckBox14: TCheckBox;
    CheckBox15: TCheckBox;
    CheckBox16: TCheckBox;
    CheckBox17: TCheckBox;
    CheckBox18: TCheckBox;
    CheckBox19: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox20: TCheckBox;
    CheckBox21: TCheckBox;
    CheckBox22: TCheckBox;
    CheckBox23: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    CheckBox9: TCheckBox;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    ComboBox4: TComboBox;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Label1: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Notebook1: TNotebook;
    Page1: TPage;
    Page2: TPage;
    Page3: TPage;
    Page4: TPage;
    Page5: TPage;
    Page6: TPage;
    Page7: TPage;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    SpinEdit3: TSpinEdit;
    SpinEdit4: TSpinEdit;
    StringGrid1: TStringGrid;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Form2: TForm2;

Procedure GetSettings(Value:TSettings);

implementation

uses Unit1;

function TFillModeToString(Value: TFillMode): String;
begin
  case value of
    fmUnchanged: result := 'Do not use file';
    fmAddNewWord: result := 'Add new words only';
    fmUse: result := 'Use file';
    fmExceptDirect: result := 'Use file (except standard directives)';
    fmAddUse: result := 'Add and use';
    fmAddUseExcept: result := 'Add and use (except standard directives)';
  end;
end;

function TCaseToString(Value: TCase):String;
begin
  case Value of
    rfLowerCase: result := 'Lower case';
    rfUpperCase: result := 'Upper case';
    rfFirstUp: result := 'Only first up';
    rfUnchanged: result := 'Unchanged';
  end;
end;

function TFeedBeginToString(Value: TFeedBegin): String;
begin
  case value of
    Unchanged: result := 'Unchanged';
    Hanging: result := 'Hanging begin';
    NewLine: result := 'Break before and after "begin"';
  end;
end;

function TSpaceBeforeToString(Value: TSpaceBefore):String;
begin
  case Value of
    spNone: result := 'None';
    spBefore: result := 'Before only';
    spAfter: result := 'After only';
    spBoth: result := 'Before and after';
  end;
end;

Procedure GetSettings(Value: TSettings);
begin
(*
  Noch nicht benutzt.

  TSettings = packed record
    ShortCut: Word;
  end;
*)
  with form2 do begin
  // Indent
    SpinEdit1.value := Value.SpacePerIndent;
    CheckBox1.checked := Value.indentBegin;
    CheckBox2.checked := Value.IndentTry;
    CheckBox3.checked := Value.IndentTryElse;
    CheckBox4.checked := Value.IndentCaseElse;
    CheckBox5.checked := Value.NoIndentElseIf;
    CheckBox6.checked := Value.IndentComments;
    CheckBox7.checked := Value.IndentCompDirectives;
  // Spacing
    StringGrid1.rowcount := 10;
    StringGrid1.ColWidths[0] := 250;
    StringGrid1.ColWidths[1] := 150;
    StringGrid1.ColWidths[2] := 150;
    StringGrid1.Cells[0, 0] := 'Description';
    StringGrid1.Cells[1, 0] := 'Operators';
    StringGrid1.Cells[2, 0] := 'Spacing';
    StringGrid1.Cells[0, 1] := 'Equals';
    StringGrid1.Cells[1, 1] := ':=';
    StringGrid1.Cells[2, 1] := TSpaceBeforeToString(Value.SpaceEqualOper);
    StringGrid1.Cells[0, 2] := 'Math. operators';
    StringGrid1.Cells[1, 2] := '< > = + - / * etc.';
    StringGrid1.Cells[2, 2] := TSpaceBeforeToString(Value.SpaceOperators);
    StringGrid1.Cells[0, 3] := 'Colon';
    StringGrid1.Cells[1, 3] := ':';
    StringGrid1.Cells[2, 3] := TSpaceBeforeToString(Value.SpaceColon);
    StringGrid1.Cells[0, 4] := 'Semicolon';
    StringGrid1.Cells[1, 4] := ';';
    StringGrid1.Cells[2, 4] := TSpaceBeforeToString(Value.SpaceSemiColon);
    StringGrid1.Cells[0, 5] := 'Comma';
    StringGrid1.Cells[1, 5] := ',';
    StringGrid1.Cells[2, 5] := TSpaceBeforeToString(Value.SpaceComma);
    StringGrid1.Cells[0, 6] := 'Left paranthesis';
    StringGrid1.Cells[1, 6] := '(';
    StringGrid1.Cells[2, 6] := TSpaceBeforeToString(Value.SpaceLeftHook);
    StringGrid1.Cells[0, 7] := 'Right paranthesis';
    StringGrid1.Cells[1, 7] := ')';
    StringGrid1.Cells[2, 7] := TSpaceBeforeToString(Value.SpaceRightHook);
    StringGrid1.Cells[0, 8] := 'Left bracket';
    StringGrid1.Cells[1, 8] := '[';
    StringGrid1.Cells[2, 8] := TSpaceBeforeToString(Value.SpaceLeftBr);
    StringGrid1.Cells[0, 9] := 'Right bracket';
    StringGrid1.Cells[1, 9] := ']';
    StringGrid1.Cells[2, 9] := TSpaceBeforeToString(Value.SpaceRightBr);
  // Line breaks
    CheckBox8.checked := Value.FeedAfterVar;
    CheckBox9.checked := Value.FeedBeforeEnd;
    CheckBox10.checked := Value.FeedAfterSemiColon;
    CheckBox11.checked := Value.FeedElseIf;
    CheckBox12.checked := Value.FeedAfterThen;
    CheckBox13.checked := Value.ExceptSingle;
    CheckBox14.checked := Value.NoFeedBeforeThen;
    CheckBox15.checked := Value.FeedEachUnit;
    CheckBox16.checked := Value.RemoveDoubleBlank;
    CheckBox17.checked := Value.BlankProc;
    CheckBox18.checked := Value.BlankSubProc;
    CheckBox19.checked := Value.WrapLines;
    SpinEdit2.Value := Value.WrapPosition;
    ComboBox1.text := TFeedBeginToString(Value.FeedRoundBegin);
  // Capitalization
    ComboBox2.text := TCaseToString(Value.ReservedCase);
    ComboBox3.text := TCaseToString(Value.StandDirectivesCase);
    ComboBox4.text := TFillModeToString(Value.FillNewWords);
    CheckBox20.checked := Value.UpperCompDirectives;
    CheckBox21.checked := Value.UpperNumbers;
  // Align
    CheckBox22.checked := Value.AlignComments;
    Spinedit3.value := value.AlignCommentPos;
    CheckBox23.checked := Value.AlignVar;
    Spinedit4.value := value.AlignVarPos;
  // Misc.
    Edit2.text := value.StartCommentOut;
    Edit3.text := value.EndCommentOut;
  end;
end;

Function ReadSettings: TSettings;
Begin
  With form2 Do Begin
    // Indent
    result.SpacePerIndent := SpinEdit1.value;
    result.indentBegin := CheckBox1.checked;
    result.IndentTry := CheckBox2.checked;
    result.IndentTryElse := CheckBox3.checked;
    result.IndentCaseElse := CheckBox4.checked;
    result.NoIndentElseIf := CheckBox5.checked;
    result.IndentComments := CheckBox6.checked;
    result.IndentCompDirectives := CheckBox7.checked;
    result.ChangeIndent :=
      result.indentBegin Or
      result.IndentTry Or
      result.IndentTryElse Or
      result.IndentCaseElse Or
      Not result.NoIndentElseIf Or
      result.IndentComments Or
      result.IndentCompDirectives;
    // Spacing
      //StringGrid1.Cells[2, 1] := TSpaceBeforeToString(Value.SpaceEqualOper);
      //StringGrid1.Cells[2, 2] := TSpaceBeforeToString(Value.SpaceOperators);
      //StringGrid1.Cells[2, 3] := TSpaceBeforeToString(Value.SpaceColon);
      //StringGrid1.Cells[2, 4] := TSpaceBeforeToString(Value.SpaceSemiColon);
      //StringGrid1.Cells[2, 5] := TSpaceBeforeToString(Value.SpaceComma);
      //StringGrid1.Cells[2, 6] := TSpaceBeforeToString(Value.SpaceLeftHook);
      //StringGrid1.Cells[2, 7] := TSpaceBeforeToString(Value.SpaceRightHook);
      //StringGrid1.Cells[2, 8] := TSpaceBeforeToString(Value.SpaceLeftBr);
      //StringGrid1.Cells[2, 9] := TSpaceBeforeToString(Value.SpaceRightBr);
    // Line breaks
    result.FeedAfterVar := CheckBox8.checked;
    result.FeedBeforeEnd := CheckBox9.checked;
    result.FeedAfterSemiColon := CheckBox10.checked;
    result.FeedAfterThen := CheckBox12.checked;
    result.ExceptSingle := CheckBox13.checked;
    result.NoFeedBeforeThen := CheckBox14.checked;
    result.FeedEachUnit := CheckBox15.checked;
    result.RemoveDoubleBlank := CheckBox16.checked;
    result.BlankProc := CheckBox17.checked;
    result.BlankSubProc := CheckBox18.checked;
    result.WrapLines := CheckBox19.checked;
    result.WrapPosition := SpinEdit2.Value;
    //ComboBox1.text := TFeedBeginToString(Value.FeedRoundBegin);
    // Capitalization
    //ComboBox2.text := TCaseToString(Value.ReservedCase);
    //ComboBox3.text := TCaseToString(Value.StandDirectivesCase);
    //ComboBox4.text := TFillModeToString(Value.FillNewWords);
    Result.UpperCompDirectives := CheckBox20.checked;
    Result.UpperNumbers := CheckBox21.checked;
    // Align
    result.AlignComments := CheckBox22.checked;
    result.AlignCommentPos := Spinedit3.value;
    result.AlignVar := CheckBox23.checked;
    result.AlignVarPos := Spinedit4.value;
    // Misc.
    result.StartCommentOut := Edit2.text;
    result.EndCommentOut := Edit3.text;
  End;
End;

{ TForm2 }

procedure TForm2.Button2Click(Sender: TObject);
begin
  close;
end;

procedure TForm2.Button1Click(Sender: TObject);
begin
  settings := readSettings;
  close;
end;

initialization
  {$I unit2.lrs}

end.

